
  /*
   All Emoncms code is released under the GNU Affero General Public License.
   See COPYRIGHT.txt and LICENSE.txt.

    ---------------------------------------------------------------------
    Emoncms - open source energy visualisation
    Part of the OpenEnergyMonitor project:
    http://openenergymonitor.org
  */

function curl_widgetlist()
{
  var widgets = {
    "curl":
    {
      "offsetx":-40,"offsety":-40,"width":80,"height":80,
      "menu":"Widgets",
      "options":["IP","port","payload","colour"],
 //   "optionstype":["value","value","value"],
      "optionsname":["IP-adress","port","payload","colour"],
      "optionshint":[_Tr("IP-adress of server"),_Tr("listen-Port of server"),_Tr("SendString"),_Tr("0=rd, 1=gn, 2=gy, 3=bu, 4=vio, 5=ye, >5=bk")]
    }
  }

  curl_events();

  return widgets;
}

function curl_events()
{
  $('.curl').on("click", function(event) {

//     $.ajax({type:'GET', url:'http://'+$(this).attr("IP")+':'+$(this).attr("port"), data: $(this).attr("payload"), timeout: 500 });		
    $.ajaxSetup({headers: false });
    $.ajax({type:'GET', url:'http://'+$(this).attr("IP")+':'+$(this).attr("port"), data: $(this).attr("payload"), timeout: 100, });		

	});
}

function curl_init()
{
  setup_widget_canvas('curl');
}

function curl_draw()
{
  $('.curl').each(function(index)
  {
    var id = "can-"+$(this).attr("id");
    var col = $(this).attr("colour");
    draw_curl(widgetcanvas[id], col);
  });
}

function curl_slowupdate()
{
  curl_draw();
}

function curl_fastupdate()
{
}


function draw_curl(circle,status)
{
  if (!circle) return;
  circle.clearRect(0,0,80,80);

  circle.fillStyle = "#ddd";
  circle.beginPath();
  circle.rect(0, 0, 40, 40)
 // circle.arc(40,40,25, 0,Math.PI * 2,false);
  circle.closePath();
  circle.fill()

  var radgrad = circle.createRadialGradient(40,40,0,40,40,20);

  if (status==0) {                              // 0=red
    radgrad.addColorStop(0, '#F75D59');
    radgrad.addColorStop(0.9, '#C11B17');
  } else if (status>0 && status <=1) {          // 1=green
    radgrad.addColorStop(0, '#A7D30C');
    radgrad.addColorStop(0.9, '#019F62');
  } else if (status>1 && status <=2) {          // 2=grey
    radgrad.addColorStop(0, '#736F6E');
    radgrad.addColorStop(0.9, '#4A4344');
  } else if (status>2 && status <=3) {          // 3=Blue
    radgrad.addColorStop(0, '#00C9FF');
    radgrad.addColorStop(0.9, '#00B5E2');
  } else if (status>3 && status <=4) {          // 4=Purple
    radgrad.addColorStop(0, '#FF5F98');
    radgrad.addColorStop(0.9, '#FF0188');
  } else if (status>4 && status <=5)   {        // 5=yellow
    radgrad.addColorStop(0, '#F4F201');
    radgrad.addColorStop(0.9, '#E4C700');
  } else {					                    // >6=Black
    radgrad.addColorStop(0, '#000000');
    radgrad.addColorStop(0.9, '#000000');
  }

  radgrad.addColorStop(1, 'rgba(1,159,98,0)');
  // draw shapes
  circle.fillStyle = radgrad;
  circle.fillRect(20,20,60,60);
}

