/*
   All emon_widgets code is released under the GNU General Public License v3.
   See COPYRIGHT.txt and LICENSE.txt.

    ---------------------------------------------------------------------
    Part of the OpenEnergyMonitor project:
    http://openenergymonitor.org

    Author: Trystan Lea: trystan.lea@googlemail.com
    If you have any questions please get in touch, try the forums here:
    http://openenergymonitor.org/emon/forum
 */

function feedvalue_widgetlist()
{
  var widgets = {
    "feedvalue": 
    {
      "offsetx":-40,"offsety":-30,"width":80,"height":60,
      "menu":"Widgets",
      "options":["feedname","units","ploca1"],
      "optionstype":["feed","value","value"],
      "optionsname":[_Tr("Feed"),_Tr("Units"),_Tr("Dashboard")],
      "optionshint":[_Tr("Feed value"),_Tr("Units to show"),_Tr("call Dashboard")] 
    }
  }
  return widgets;
}

function feedvalue_init()
{
  feedvalue_draw();
}

function feedvalue_draw()
{
  $('.feedvalue').each(function(index)
  {
    var feed = $(this).attr("feedname");
    if (feed==undefined) feed = $(this).attr("feed");

    var units = $(this).attr("units");
    var val = assoc[feed];

    if (feed==undefined) val = 0;
    if (units==undefined) units = '';
    if (val==undefined) val = 0;

    var ploca1 = $(this).attr("ploca1");
    if (ploca1==undefined) ploca1 = 0;

    if (val < 100) {
      val = val.toFixed(1);
    }
    else {
      val = val.toFixed(0);
    }
      
    var rHfeed = feed.search("rH");
    var tempfeed = feed.search("Temp");
    var kampmhtempfeed = feed.search("Temp_Prostor");
    var kampmhvanitempfeed = feed.search("VaniTemp");
    var bojlerfeed = feed.search("TB");
    var kampbojlerfeed = feed.search("Temp_Bojler");
    var bojler_zadanofeed = feed.search("TB_Zadano");
    var hladfeed = feed.search("F");
    var zamrfeed = feed.search("F");
    var prosfeed = feed.search("P");
    var hl28feed = feed.search("2-8");
    var hl815feed = feed.search("8-15"); 
    var hl60feed = feed.search("-60");
    var hl50feed = feed.search("-50");
    var hl40feed = feed.search("-40");
    var hl30feed = feed.search("-30");
    var hl20feed = feed.search("-20");
    var RSSIfeed = feed.search("RSSI");
    var Vrmsfeed = feed.search("Vrms");
    var predstr = "";
    
    if (ploca1 > 0) {   
      var kursor = "; cursor:pointer";
    } else { 
      var kursor = "";
    }
    var color = "rgb(50,200,50)";  //zelena
    
    

    if (rHfeed>-1) {  //feed je rH
      if (val<40) color = "rgb(255,128,0)";  //naranđasta
      if (val>60) color = "rgb(255,128,0)";  //naranđasta
      predstr = "rH>";
    }
    
    if (bojlerfeed>-1) {  //feed je bojler
      if (val>50) color = "rgb(255,0,0)";  //crvena
      if (val>=40 && val<=50 ) color = "rgb(255,102,102)";  //svijetlo crvena
      if (val>30 && val<40 ) color = "rgb(255,128,0)";  //naranđasta
      if (val>=24 && val<=30 ) color = "rgb(127,0,255)";  //ljubičasta     
      if (val<24 ) color = "rgb(0,0,255)";  //plava
      predstr = "Bojler>";
    }
   
    if (bojler_zadanofeed>-1) {  //feed je bojler zadana temperatura
      if (val>50) color = "rgb(255,0,0)";  //crvena
      if (val>=40 && val<=50 ) color = "rgb(255,102,102)";  //svijetlo crvena
      if (val>30 && val<40 ) color = "rgb(255,128,0)";  //naranđasta
      if (val>=24 && val<=30 ) color = "rgb(127,0,255)";  //ljubičasta     
      if (val<24 ) color = "rgb(0,0,255)";  //plava
      predstr = "Set bojler temp>";
    }

    if (kampbojlerfeed>-1) {  //feed je el bojler kamp
      if (val>50) color = "rgb(255,0,0)";  //crvena
      if (val>=40 && val<=50 ) color = "rgb(255,102,102)";  //svijetlo crvena
      if (val>30 && val<40 ) color = "rgb(255,128,0)";  //naranđasta
      if (val>=24 && val<=30 ) color = "rgb(127,0,255)";  //ljubičasta     
      if (val<24 ) color = "rgb(0,0,255)";  //plava
      predstr = "Bojler>";
    }

    if (tempfeed>-1 && prosfeed>-1) {   // temp prostora
      if (val>24.4) color = "rgb(255,128,0)";  //naranđasta
      if (val>25) color = "rgb(255,0,0)"; //crvena
      predstr = "TP>";
    }

    if (kampmhtempfeed>-1) {   // temp prostora  kamping
      if (val<5) color = "rgb(0,0,255)";  //tam.plava
      if (val<=18) color = "rgb(51,153,255)";  //sv.plava
      if (val>18 && val < 25) color = "rgb(50,200,50)";  //zelena
      if (val>=25) color = "rgb(255,128,0)";  //naranđasta
      if (val>35) color = "rgb(255,0,0)"; //crvena
      predstr = "TP>";
    }
    
    if (kampmhvanitempfeed>-1) {   // temp prostora  kamping
      if (val<5) color = "rgb(0,0,255)";  //tam.plava
      if (val<=18) color = "rgb(51,153,255)";  //sv.plava
      if (val>18 && val < 25) color = "rgb(50,200,50)";  //zelena
      if (val>=25) color = "rgb(255,128,0)";  //naranđasta
      if (val>35) color = "rgb(255,0,0)"; //crvena
      predstr = "TP>";
    }
      
    if (hladfeed>-1 && hl28feed >-1) {  // hladnjak 2-8
      if (val<2) color = "rgb(51,153,255)";  //sv.plava
      if (val<0) color = "rgb(0,0,255)";  //tam.plava
      if (val>7.5) color = "rgb(255,128,0)";  //naranđasta
      if (val>8) color = "rgb(255,0,0)"; //crvena 
      if (val>=2 && val <=7.5) color = "rgb(50,200,50)";  //zelena 
      predstr = "F2-8>"; 
    }
    
    if (hladfeed>-1 && hl815feed >-1) {  // hladnjak 8-15
      if (val<8) color = "rgb(51,153,255)";  //sv.plava
      if (val<2) color = "rgb(0,0,255)";  //tam.plava
      if (val>14.5) color = "rgb(255,128,0)";  //naranđasta
      if (val>15) color = "rgb(255,0,0)"; //crvena
      if (val>=8 && val <=14.5) color = "rgb(50,200,50)";  //zelena
      predstr = "F8-15>";    
    }

    if (zamrfeed>-1 && hl20feed>-1) {  // hladnjak -20  modificirano za OBZ
      if (val<-30) color = "rgb(51,153,255)";  //sv.plava
      if (val<-32) color = "rgb(0,0,255)";  //tam.plava
      if (val>-22) color = "rgb(255,128,0)";  //naranđasta
      if (val>-20) color = "rgb(255,0,0)"; //crvena
      if (val>=-30 && val <=-20) color = "rgb(50,200,50)";  //zelena
      predstr = "F-20>";   
    }
    
    if (zamrfeed>-1 && hl30feed>-1) {  // hladnjak -30
      if (val<-30) color = "rgb(51,153,255)";  //sv.plava
      if (val<-25) color = "rgb(0,0,255)";  //tam.plava
      if (val>-18) color = "rgb(255,128,0)";  //naranđasta
      if (val>-17) color = "rgb(255,0,0)"; //crvena
      if (val>=-30 && val <=-25) color = "rgb(50,200,50)";  //zelena
      predstr = "F-30>";   
    }
    
    if (zamrfeed>-1 && hl40feed>-1) {  // hladnjak -40
      if (val<-40) color = "rgb(51,153,255)";  //sv.plava
      if (val<-42) color = "rgb(0,0,255)";  //tam.plava
      if (val>-35) color = "rgb(255,128,0)";  //naranđasta
      if (val>-30) color = "rgb(255,0,0)"; //crvena
      if (val>=-40 && val <=-35) color = "rgb(50,200,50)";  //zelena
      predstr = "F-40>";      
    }

    if (zamrfeed>-1 && hl50feed>-1) {  // hladnjak -50
      if (val<-52) color = "rgb(51,153,255)";  //sv.plava
      if (val<-54) color = "rgb(0,0,255)";  //tam.plava
      if (val>-45) color = "rgb(255,128,0)";  //naranđasta
      if (val>-40) color = "rgb(255,0,0)"; //crvena
      if (val>=-52 && val <=-45) color = "rgb(50,200,50)";  //zelena
      predstr = "Z-50>";      
    }
    
    if (zamrfeed>-1 && hl60feed>-1) {  // hladnjak -60
      if (val<-60) color = "rgb(51,153,255)";  //sv.plava
      if (val<-62) color = "rgb(0,0,255)";  //tam.plava
      if (val>-55) color = "rgb(255,128,0)";  //naranđasta
      if (val>-50) color = "rgb(255,0,0)"; //crvena
      if (val>=-60 && val <=-55) color = "rgb(50,200,50)";  //zelena
      predstr = "Z-60>";      
    }

    if (RSSIfeed>-1) {  //feed je RSSI
      if (val<40) color = "rgb(255,128,0)";  //naranđasta
      if (val>50) color = "rgb(50,200,50)";  //zelena
      predstr = "RSSI>";
    }


   if (Vrmsfeed>-1) {  //feed je napon
      if (val>230) color = "rgb(255,0,0)";  //crvena
      if (val>225 && val<230 ) color = "rgb(255,128,0)";  //naranđasta
      if (val>=200 && val<=215 ) color = "rgb(255,128,0)";  //naranđasta   
      if (val<200 ) color = "rgb(255,102,102)";  //svijetlo crvena
      predstr = "Napon>";
    }

    // $(this).html(val+units);
    

    $(this).click(function() {
       snd = '';
       if (ploca1 > 0) {
         window.location.href = 'http://emon-bns.com/obo/dashboard/view?id='+$(this).attr("ploca1");
       }
       
    });


    $(this).html("<span style='color:"+color+""+kursor+"'>"+val+units+"</span>");

    
    


  });
}

function feedvalue_slowupdate()
{
  feedvalue_draw();
}

function feedvalue_fastupdate()
{
}