<?php
/*
   All Emoncms code is released under the GNU Affero General Public License.
   See COPYRIGHT.txt and LICENSE.txt.

   ---------------------------------------------------------------------
   Emoncms - open source energy visualisation
   Part of the OpenEnergyMonitor project:
   http://openenergymonitor.org
*/

// no direct access
defined('EMONCMS_EXEC') or die('Restricted access');

class User
{
    
    private $mysqli;
    private $rememberme;
    private $enable_rememberme = false;
    public function __construct($mysqli,$rememberme)
    {
        //copy the settings value, otherwise the enable_rememberme will always be false.
        global $enable_rememberme;
       
        $this->enable_rememberme = $enable_rememberme;
	
        $this->mysqli = $mysqli;
        $this->rememberme = $rememberme;
        
    }

    //---------------------------------------------------------------------------------------
    // Core session methods
    //---------------------------------------------------------------------------------------




    public function apikey_session($apikey_in)
    {
        
       
        $session = array();
        global $vremenska_korekcija;
        
        //----------------------------------------------------
        // Check for apikey login
        //----------------------------------------------------
        $apikey_in = $this->mysqli->real_escape_string($apikey_in);

        $result = $this->mysqli->query("SELECT id,feed_list,dash_list FROM users WHERE apikey_read='$apikey_in'");
        if ($result->num_rows == 1) 
        {
            $row = $result->fetch_array();
            if ($row['id'] != 0)
            {
                //session_regenerate_id();
                 
                // rade grafovi pozvani kroz drugu aplikaciju sa read apikey!!
                if (!isset($_SESSION['start'])){
                  session_start();
                }
                
                
                $session['userid'] = $row['id'];
                $session['read'] = 1;
                $session['write'] = 0;
                $session['admin'] = 0;
                $session['editmode'] = TRUE;
                $session['lang'] = "en";
                $session['feed_list'] = $row['feed_list'];
                $session['dash_list'] = $row['dash_list'];
           
    
               
            }
        }

        $result = $this->mysqli->query("SELECT id FROM users WHERE apikey_write='$apikey_in'");
        if ($result->num_rows == 1) 
        {
            $row = $result->fetch_array();
            if ($row['id'] != 0)
            {
                //session_regenerate_id();
                
                // rade grafovi pozvani kroz drugu aplikaciju sa read apikey!!
                if (!isset($_SESSION['start'])){
                  session_start();
                }
                $session['userid'] = $row['id'];
                $session['read'] = 1;
                $session['write'] = 1;
                $session['admin'] = 0;
                $session['editmode'] = TRUE;
                $session['lang'] = "en";

   
    
            }
        }
        //----------------------------------------------------
    if (isset($_GET['start'])){
      $_SESSION['dateod'] = strtotime($_GET["start"]) ;
      error_log("uzeo start iz apikey\n", 3, "errori.log");
    } else {
      //$_SESSION['dateod'] = time()-(3600*24.0*7);
      error_log("Nema start variable iz apikey\n", 3, "errori.log");
    }
   
    
    if (isset($_GET['end'])){
      $_SESSION['datedo'] = strtotime($_GET["end"]) +(24*3600) - $vremenska_korekcija ;
     
    } else {
      //$_SESSION['datedo'] = time();
    }
  
       if (isset($_SESSION['dateod'])) {
         $session['dateod'] = $_SESSION['dateod'];
       } else { 
         $session['dateod'] =  time()-(3600*24.0*7);
       }

       if (isset($_SESSION['datedo'])) {
         $session['datedo'] = $_SESSION['datedo'];
       } else { 
         //$session['datedo'] = time();
       }
        
     
      return $session;
    }

    public function emon_session_start()
    {
        global $vremenska_korekcija;
        session_start();
         
        if ($this->enable_rememberme)
        {
            
            // if php session exists
            if (!empty($_SESSION['userid'])) {
              
              // if rememberme emoncms cookie exists but is not valid then  
              // a valid cookie is a cookie who's userid, token and persistant token match a record in the db
              if(!empty($_COOKIE[$this->rememberme->getCookieName()]) && !$this->rememberme->cookieIsValid($_SESSION['userid'])) {
                $this->logout();
              }
            } else {
              $loginresult = $this->rememberme->login();
              if ($loginresult) 
              {
                // Remember me login
                $_SESSION['userid'] = 1;
                $_SESSION['read'] = 1;
                $_SESSION['write'] = 0;
                // There is a chance that an attacker has stolen the login token, so we store
                // the fact that the user was logged in via RememberMe (instead of login form)
                $_SESSION['cookielogin'] = true;
                /*
                $_SESSION['admin'] = 0;
                $_SESSION['lang'] = $userData->language;
                $_SESSION['editmode'] = FALSE;
                $_SESSION['feed_list'] = $userData->feed_list;
                $_SESSION['dash_list'] = $userData->dash_list;
                */
               
              } else
              {
                if($this->rememberme->loginTokenWasInvalid()) {
                  // Stolen
                  
                }
              }
            }
        }

        //error_log($_SESSION['username'], 3, "errori.log"); 

        if (isset($_SESSION['admin'])) $session['admin'] = $_SESSION['admin']; else $session['admin'] = 0;
        if (isset($_SESSION['read'])) $session['read'] = $_SESSION['read']; else $session['read'] = 0;
        if (isset($_SESSION['write'])) $session['write'] = $_SESSION['write']; else $session['write'] = 0;
        if (isset($_SESSION['userid'])) $session['userid'] = $_SESSION['userid']; else $session['userid'] = 0;
        if (isset($_SESSION['lang'])) $session['lang'] = $_SESSION['lang']; else $session['lang'] = '';
        if (isset($_SESSION['username'])) $session['username'] = $_SESSION['username']; else $session['username'] = '';
        if (isset($_SESSION['cookielogin'])) $session['cookielogin'] = $_SESSION['cookielogin']; else $session['cookielogin'] = 0;
        if (isset($_SESSION['feed_list'])) $session['feed_list'] = $_SESSION['feed_list']; else $session['feed_list'] = '';
        if (isset($_SESSION['dash_list'])) $session['dash_list'] = $_SESSION['dash_list']; else $session['dash_list'] = '';



    if (isset($_GET['start'])){
      $_SESSION['dateod'] = strtotime($_GET["start"]) ;
      error_log("uzeo start iz rute iz programa\n", 3, "errori.log");
    } else {
      //$_SESSION['dateod'] = time()-(3600*24.0*7);
      error_log("Nema start variable iz rute iz programa\n", 3, "errori.log");
    }
   
    
    if (isset($_GET['end'])){
      $_SESSION['datedo'] = strtotime($_GET["end"]) +(24*3600) - $vremenska_korekcija ;
     
    } else {
      //$_SESSION['datedo'] = time();
    }
        // kada se ruta poziva iz programa ovo je potrebno
        error_log("Ruta iz programa\n", 3, "errori.log");
        if (isset($_SESSION['dateod'])) $session['dateod'] = $_SESSION['dateod']; else $session['dateod'] = time()-(3600*24.0*7);
        if (isset($_SESSION['datedo'])) $session['datedo'] = $_SESSION['datedo']; else $session['datedo'] = time();
 

        //error_log("this-rememberme : ".var_export($this->enable_rememberme,true)."\n\r", 3, "errori.log");
        
        return $session;
    }


    public function register($username, $password, $email)
    {
        // Input validation, sanitisation and error reporting
        if (!$username || !$password || !$email) return array('success'=>false, 'message'=>_("Nedostaje korisnicko ime, zaporka ili email adresa"));

        if (!ctype_alnum($username)) return array('success'=>false, 'message'=>_("Korisnicko ime treba biti sastavljeno samo od slova a-z i brojeva 0-9"));
        $username = $this->mysqli->real_escape_string($username);
        $password = $this->mysqli->real_escape_string($password);

        if ($this->get_id($username) != 0) return array('success'=>false, 'message'=>_("Korisnicko ime postoji, izaberite drugo"));

        if (!filter_var($email, FILTER_VALIDATE_EMAIL)) return array('success'=>false, 'message'=>_("Email adresa pogrešno upisana"));

        if (strlen($username) < 4 || strlen($username) > 30) return array('success'=>false, 'message'=>_("Korisnicko ime mora imati od 4 do 30 znakova"));
        if (strlen($password) < 4 || strlen($password) > 30) return array('success'=>false, 'message'=>_("Zaporka mora imati od 4 do 30 znakovar"));

        // If we got here the username, password and email should all be valid

        $hash = hash('sha256', $password);
        $string = md5(uniqid(mt_rand(), true));
        $salt = substr($string, 0, 3);
        $hash = hash('sha256', $salt . $hash);

        $apikey_write = md5(uniqid(mt_rand(), true));
        $apikey_read = md5(uniqid(mt_rand(), true));

        if (!$this->mysqli->query("INSERT INTO users ( username, password, email, salt ,apikey_read, apikey_write, admin ) VALUES ( '$username' , '$hash', '$email', '$salt', '$apikey_read', '$apikey_write', 0 );")) {
        	return array('success'=>false, 'message'=>_("Greska kod kreiranja novog korisnika"));
        }
        
        // Make the first user an admin
        $userid = $this->mysqli->insert_id;
        if ($userid == 1) $this->mysqli->query("UPDATE users SET admin = 1 WHERE id = '1'");

        return array('success'=>true, 'userid'=>$userid, 'apikey_read'=>$apikey_read, 'apikey_write'=>$apikey_write);
    }

    public function login($username, $password, $remembermecheck)
    {
        
      
        $remembermecheck = (int) $remembermecheck;

        if (!$username || !$password) return array('success'=>false, 'message'=>_("Korisnicko ime ili zaporka nisu upisani"));

        // filter out all except for alphanumeric white space and dash
        //if (!ctype_alnum($username)) 
        $username_out = preg_replace('/[^\w\s-]/','',$username); 

        if ($username_out!=$username) return array('success'=>false, 'message'=>_("Korisnicko ime treba biti sastavljeno samo od slova a-z i brojeva 0-9"));

        $username = $this->mysqli->real_escape_string($username);
        $password = $this->mysqli->real_escape_string($password);

        $result = $this->mysqli->query("SELECT id,password,admin,salt,language,feed_list,dash_list FROM users WHERE username = '$username'");

        if ($result->num_rows < 1) return array('success'=>false, 'message'=>_("Korisnicko ime ne postoji!"));
     
        $userData = $result->fetch_object();

        $hash = hash('sha256', $userData->salt . hash('sha256', $password));

        if ($hash != $userData->password) 
        {
            return array('success'=>false, 'message'=>_("Neispravna zaporka, ako ste sigurni da je ispravna ispraznite spremnik preglednika"));
        }
        else
        {
            session_regenerate_id();
            if ($username == 'brankos')
            {
            $_SESSION['userid'] = $userData->id;
            $_SESSION['username'] = $username;
            $_SESSION['read'] = 1;
            $_SESSION['write'] = 1;
            $_SESSION['admin'] = $userData->admin;
            $_SESSION['lang'] = $userData->language;
            $_SESSION['editmode'] = TRUE;
            $_SESSION['feed_list'] = $userData->feed_list;
            $_SESSION['dash_list'] = $userData->dash_list;
            
            
            } else {
            //$_SESSION['userid'] = 1;
            $_SESSION['userid'] = $userData->id;
            $_SESSION['username'] = $username;
            $_SESSION['read'] = 1;
            //$_SESSION['write'] = 0;
            $_SESSION['write'] = 1;
            $_SESSION['admin'] = 0;
            $_SESSION['lang'] = $userData->language;
            $_SESSION['editmode'] = FALSE;
            $_SESSION['feed_list'] = $userData->feed_list;
            $_SESSION['dash_list'] = $userData->dash_list;

            }
            // poslije logina
            $_SESSION['dateod'] = time()-(3600*24.0*7);
            $_SESSION['datedo'] = time();
             
            error_log("Ruta Login blok\n", 3, "errori.log");

            if ($this->enable_rememberme) {
                if ($remembermecheck==true) {
                    $this->rememberme->createCookie($userData->id);
                } else {
                    $this->rememberme->clearCookie();
                }
            }
            
           
            
   
            return array('success'=>true, 'message'=>_("Prijava je uspjela!"));
        }
    }

    public function logout()
    {
        if ($this->enable_rememberme) $this->rememberme->clearCookie(true);
        /*
        $_SESSION['userid'] = 0;
        $_SESSION['read'] = 0;
        $_SESSION['write'] = 0;
        $_SESSION['admin'] = 0;
        $_SESSION['feed_list'] = '';
        $_SESSION['dash_list'] = '';
        */
        //session_regenerate_id(true);
        session_unset();
        session_destroy();
        
    }

    public function change_password($userid, $old, $new)
    {
        $userid = intval($userid);
        $old = $this->mysqli->real_escape_string($old);
        $new = $this->mysqli->real_escape_string($new);

        if (strlen($old) < 4 || strlen($old) > 30) return array('success'=>false, 'message'=>_("Zaporka mora imati od 4 do 30 znakova"));
        if (strlen($new) < 4 || strlen($new) > 30) return array('success'=>false, 'message'=>_("Zaporka mora imati od 4 do 30 znakova"));

        // 1) check that old password is correct
        $result = $this->mysqli->query("SELECT password, salt FROM users WHERE id = '$userid'");
        $row = $result->fetch_object();
        $hash = hash('sha256', $row->salt . hash('sha256', $old));

        if ($hash == $row->password)
        {
            // 2) Save new password
            $hash = hash('sha256', $new);
            $string = md5(uniqid(rand(), true));
            $salt = substr($string, 0, 3);
            $hash = hash('sha256', $salt . $hash);
            $this->mysqli->query("UPDATE users SET password = '$hash', salt = '$salt' WHERE id = '$userid'");
            return array('success'=>true);
        }
        else
        {
            return array('success'=>false, 'message'=>_("Stara zaporka je neispravna"));
        }
    }

    public function change_username($userid, $username)
    {
        if (isset($_SESSION['cookielogin']) && $_SESSION['cookielogin']==true) return array('success'=>false, 'message'=>_("Ako koristite 'cookie' zapamti me prijavu, odjavite se i ponovite prijavu za izmjenu korisnickog imena"));

        $userid = intval($userid);
        if (strlen($username) < 4 || strlen($username) > 30) return array('success'=>false, 'message'=>_("Korisnièko ime mora imati od 4 do 30 znakova"));

        if (!ctype_alnum($username)) return array('success'=>false, 'message'=>_("Korisnièko ime treba biti sastavljeno samo od slova a-z i brojeva 0-9 "));

        $result = $this->mysqli->query("SELECT id FROM users WHERE username = '$username'");
        $row = $result->fetch_array();
        if (!$row[0]) 
        {
            $this->mysqli->query("UPDATE users SET username = '$username' WHERE id = '$userid'");
            return array('success'=>true, 'message'=>_("Korisnièko ime je izmjenjeno"));
        }
        else
        {
            return array('success'=>false, 'message'=>_("Korisnièko ime postoji, izaberite drugo"));
        }
    }

    public function change_email($userid, $email)
    {
        if (isset($_SESSION['cookielogin']) && $_SESSION['cookielogin']==true) return array('success'=>false, 'message'=>_("Ako koristite 'cookie' zapamti me prijavu, odjavite se i ponovite prijavu za izmjenu email adrese"));

        $userid = intval($userid);
        if (!filter_var($email, FILTER_VALIDATE_EMAIL)) return array('success'=>false, 'message'=>_("Email formatna pogreska"));

        $this->mysqli->query("UPDATE users SET email = '$email' WHERE id = '$userid'");
        return array('success'=>true, 'message'=>_("Email adresa obnovljena"));
    }

    //---------------------------------------------------------------------------------------
    // Get by userid methods
    //---------------------------------------------------------------------------------------

    public function get_convert_status($userid)
    {
        $userid = intval($userid);
        $result = $this->mysqli->query("SELECT `convert` FROM users WHERE id = '$userid';");
        $row = $result->fetch_array();
        return array('convert'=>(int)$row['convert']);
    }

    public function get_username($userid)
    {
        $userid = intval($userid);
        $result = $this->mysqli->query("SELECT username FROM users WHERE id = '$userid';");
        $row = $result->fetch_array();
        return $row['username'];
    }

    public function get_apikey_read($userid)
    {
        $userid = intval($userid);
        $result = $this->mysqli->query("SELECT `apikey_read` FROM users WHERE `id`='$userid'");
        $row = $result->fetch_object();
        return $row->apikey_read;
    }

    public function get_apikey_write($userid)
    {
        $userid = intval($userid);
        $result = $this->mysqli->query("SELECT `apikey_write` FROM users WHERE `id`='$userid'");
        $row = $result->fetch_object();
        return $row->apikey_write;
    }

    public function get_lang($userid)
    {
        $userid = intval($userid);
        $result = $this->mysqli->query("SELECT lang FROM users WHERE id = '$userid';"); 
        $row = $result->fetch_array();
        return $row['lang'];
    }

    public function get_timezone($userid)
    {
        $userid = intval($userid);
        $result = $this->mysqli->query("SELECT timezone FROM users WHERE id = '$userid';");
        $row = $result->fetch_object();
        return intval($row->timezone);
    }

    public function get_salt($userid)
    {
        $userid = intval($userid);
        $result = $this->mysqli->query("SELECT salt FROM users WHERE id = '$userid'");
        $row = $result->fetch_object();
        return $row->salt;
    }

    //---------------------------------------------------------------------------------------
    // Get by other paramater methods
    //---------------------------------------------------------------------------------------

    public function get_id($username)
    {
        if (!ctype_alnum($username)) return false;

        $result = $this->mysqli->query("SELECT id FROM users WHERE username = '$username';");
        $row = $result->fetch_array();
        return $row['id'];
    }

    //---------------------------------------------------------------------------------------
    // Set by id methods
    //---------------------------------------------------------------------------------------

    public function set_convert_status($userid)
    {
        $userid = intval($userid);
        $this->mysqli->query("UPDATE users SET `convert` = '1' WHERE id='$userid'");
        return array('convert'=>1);
    }

    public function set_user_lang($userid, $lang)
    {
        $this->mysqli->query("UPDATE users SET lang = '$lang' WHERE id='$userid'");
    }

    public function set_timezone($userid,$timezone)
    {
        $userid = intval($userid);
        $timezone = intval($timezone);
        $this->mysqli->query("UPDATE users SET timezone = '$timezone' WHERE id='$userid'");
    }

    //---------------------------------------------------------------------------------------
    // Special methods
    //---------------------------------------------------------------------------------------

    public function get($userid)
    {
        $userid = intval($userid);
        $result = $this->mysqli->query("SELECT id,username,email,gravatar,name,location,timezone,language,bio FROM users WHERE id=$userid");
        $data = $result->fetch_object();
        //error_log("Get userid:".$userid."\n\r", 3, "errori.log");
        //error_log("data:".json_encode(array($data))."\n\r", 3, "errori.log");
        return $data;
    }

    public function set($userid,$data)
    {
        // Validation
        $userid = intval($userid);
        $gravatar = preg_replace('/[^\w\s-.@]/','',$data->gravatar);
        $name = preg_replace('/[^\w\s-.]/','',$data->name);
        $location = preg_replace('/[^\w\s-.]/','',$data->location);
        $timezone = intval($data->timezone);
        $language = preg_replace('/[^\w\s-.]/','',$data->language); $_SESSION['lang'] = $language;
        $bio = preg_replace('/[^\w\s-.]/','',$data->bio);

        $result = $this->mysqli->query("UPDATE users SET gravatar = '$gravatar', name = '$name', location = '$location', timezone = '$timezone', language = '$language', bio = '$bio' WHERE id='$userid'");
    }

    // Generates a new random read apikey
    public function new_apikey_read($userid)
    {
        $userid = intval($userid);
        $apikey = md5(uniqid(mt_rand(), true));
        $this->mysqli->query("UPDATE users SET apikey_read = '$apikey' WHERE id='$userid'");
        return $apikey;
    }

    // Generates a new random write apikey
    public function new_apikey_write($userid)
    {
        $userid = intval($userid);
        $apikey = md5(uniqid(mt_rand(), true));
        $this->mysqli->query("UPDATE users SET apikey_write = '$apikey' WHERE id='$userid'");
        return $apikey;
    }
}
